# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS & White Box as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "wbel"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Summary:	Perl binding of Sendmail Milter protocol
Name:		perl-Sendmail-PMilter
Version:	1.00
Release:	1.%{__distinit}%{__distvers}
License:	BSD
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Sendmail-PMilter/
Source0:	http://search.cpan.org/CPAN/authors/id/A/AV/AVAR/Sendmail-PMilter-%{version}.tar.gz
Patch0:		Sendmail-PMilter-Context.pm_pod.patch
Patch1:		Sendmail-PMilter-0.97-setdbg-settimeout.patch
Patch2:		Sendmail-PMilter-0.97-data-command.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(ExtUtils::MakeMaker), perl(Test::More)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Obsoletes:	perl-Sendmail-Milter <= 0.18

%description
Sendmail::PMilter is a mail filtering API implementing the Sendmail milter
protocol in pure Perl. This allows Sendmail servers (and perhaps other MTAs
implementing milter) to filter and modify mail in transit during the SMTP
connection, all in Perl.

It should be noted that PMilter 0.90 and later is NOT compatible with
scripts written for PMilter 0.5 and earlier.  The API has been reworked
significantly, and the enhanced APIs and rule logic provided by PMilter
0.5 and earlier has been factored out for inclusion in a separate package
called Mail::Milter.

%prep
%setup -q -n Sendmail-PMilter-%{version}

# Fix up POD errors in Sendmail::PMilter::Context
%patch0 -p1

# Pretend to have succeeeded in Sendmail::Milter::{setdb,settimeout}
# (these are no-op functions in the Sendmail::Milter implementation)
# CPAN RT#50144
%patch1 -p1

# Handle SMFIC_DATA (CPAN RT#51058)
%patch2 -p1

# Fix interpreters in examples and turn off exec bits to avoid extra deps
sed -i -e 's@/usr/local/bin/perl@/usr/bin/perl@' examples/*.pl
chmod -x examples/*.pl

%build
# Using "echo" to bypass the interactive 'yes/no' question in Makefile.PL
echo yes | perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README doc/milter-protocol.txt examples/
%{perl_vendorlib}/Sendmail/
%{_mandir}/man3/Sendmail::Milter.3pm*
%{_mandir}/man3/Sendmail::PMilter.3pm*
%{_mandir}/man3/Sendmail::PMilter::Context.3pm*

%changelog
* Mon Apr 18 2011 Paul Howarth <paul@city-fan.org> 1.00-1
- Update to 1.00
  - Avoid infinite loop: signal handler modifies errno
  - Added support for SMFIC_UNKNOWN
- Nobody else likes macros for commands

* Mon Feb  7 2011 Paul Howarth <paul@city-fan.org> 0.99-1
- Update to 0.99
  - Handle IPv6 addresses in SMFIC_CONNECT in Sendmail::PMilter::Context
    (CPAN RT#65499)

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 0.98-3
- Rebuild for perl 5.12.1 in Rawhide

* Fri May  7 2010 Paul Howarth <paul@city-fan.org> 0.98-2
- Fix dist tag to work with RHEL6 Beta

* Sat Mar 13 2010 Paul Howarth <paul@city-fan.org> 0.98-1
- Update to 0.98 (fixes for CPAN RT#51713 and CPAN RT#51759)
- Drop upstreamed POD patch (CPAN RT#51713)

* Mon Feb  8 2010 Paul Howarth <paul@city-fan.org> 0.97-3
- Cosmetic changes merged from Fedora package

* Mon Feb  8 2010 Paul Howarth <paul@city-fan.org> 0.97-2
- Add patch to handle SMFIC_DATA (CPAN RT#51058)
- Add patch from Fedora to fix POD errors in Sendmail::PMilter::Context
- Add patch for more POD fixes (CPAN RT#51713)
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro rather than our own %%{__chmod} incantation

* Fri Sep 25 2009 Paul Howarth <paul@city-fan.org> 0.97-1
- Update to 0.97 (compatible with sendmail 8.14 - CPAN RT#43327)
- Add patch to make the no-op functions Sendmail::Milter::{setdb,settimeout}
  return "success" values to avoid messages like "Failed to set timeout value!"

* Thu Sep 24 2009 Paul Howarth <paul@city-fan.org> 0.96-2
- Don't provide perl-Sendmail-Milter; avoids self-obsoletion
- Define RPM macros in global context

* Wed Apr 30 2008 Paul Howarth <paul@city-fan.org> 0.96-1
- First RPM build
